/*
Autor:		Rafael Alberto Moreno Parra
URL:		http://www.geocities.com/krousky
Clase:		Organismo
Lenguaje:	C++

Propsito:
Clase de administracin del medio ambiente (serie numrica de entrada y
salida)

Mtodos:
IniciaSemillaT: Inicializa la semilla dependiendo del tiempo
IniciaSemillaR: Inicializa la semilla aleatoriamente
sDisplayADN: Despliega el organismo como si fuera cdigo Java
vCreaADN: Crea el organismo, llamando la funcin que hace sus genes
vHaceGen: Crea una linea de codigo fuente (la llam Gen). El formato es:
          label, [, IF/SET, Variable, =/>/</!, (, expresion, ), Goto, Label, ]
          para mayor velocidad, se ubica en una clase el Gen
vEvaluaPrevio: Optimiza la velocidad de evaluacin del organismo en un
               ambiente.
fEvalOrganismo: Evalua el organismo en el ambiente
vMutaGen: Mutacin suave de un gen del organismo

*/

#include <time.h>
#include "Gen.h"
#include "EvalExpr.h"
#include "GenExpr.h"

#define NUMFUNCIONES 3

class Organismo
{
private:
	EvalExpr m_eEvalua;
    time_t ltime1;

public:
    Gen m_oGen[50]; //Genes del ser vivo
	GenExpr objGenExpr; //Para generacin de expresiones

    Organismo(); //Constrcutor
	unsigned int m_iMaxGenOrg; //Maximo numero de genes para el organismo
    unsigned int m_iMaxiCiclos; //Maximo numero de ciclos que se gastaran para evaluar el organismo
	void sDisplayADN(char *sbADN);
    void vCreaADN (bool bGenRandom, unsigned int iMaxGenes,
                   unsigned int iPosibIf, unsigned int iPosibSet,
                   unsigned int iPosW,  unsigned int iPosX, unsigned int iPosY, unsigned int iPosZ,
                   unsigned int iPosIg, unsigned int iPosMay, unsigned int iPosMen, unsigned int iPosDif,
                   unsigned int iLongExpr, unsigned int iPosibX, unsigned int iPosibY, unsigned int iPosibP, unsigned int iPosibN);
    int fEvalOrganismo (unsigned int *,
						unsigned int *,
						float *,
						float *,
						float *,
						float *);

    /* Crea una linea de codigo fuente (la llam Gen). El formato es:
       label, [, IF/SET, Variable, =/>/</!, (, expresion, ), Goto, Label, ]
       para mayor velocidad, se ubica en una clase el Gen */
    void vHaceGen(unsigned int iLabel, unsigned int iMaxGenes,
                  unsigned int iPosibIf, unsigned int iPosibSet,
                  unsigned int iPosW,  unsigned int iPosX, unsigned int iPosY, unsigned int iPosZ,
                  unsigned int iPosIg, unsigned int iPosMay, unsigned int iPosMen, unsigned int iPosDif,
                  unsigned int iLongExpr, unsigned int iPosibX, unsigned int iPosibY, unsigned int iPosibP, unsigned int iPosibN);

	//Inicia la semilla de los nmeros aleatorios
	void IniciaSemillaT();
	void IniciaSemillaR();

	//Muta suavemente un Gen
	void vMutaGen(unsigned int iLabel, unsigned int iMaxGenes,
                  unsigned int iLongExpr, unsigned int iPosibX, unsigned int iPosibY, unsigned int iPosibP, unsigned int iPosibN);
};

//Mejores Organismos (sin los mtodos)
class Mejores
{
public:
	Gen m_oGen[50]; //Genes del ser vivo
	unsigned int m_iMaxGenOrg; //Maximo numero de genes para el organismo
	unsigned int iPuntAdapta; //Adaptacion ser vivo	
};